package genetic_algorithm;

import java.io.Serializable;

/**
 * An example <code>Chromosome</code> class.
 * @author Nick Malleson
 */
public class TestChromosome extends Chromosome implements Serializable {

   /**
    * This demo class uses four Genes, each of which can vary between 0 and 10.
    * @return
    */
   @Override
   public Gene[] createGenes() {
      Gene[] thegenes = new Gene[4];
      for (int i = 0; i < 4; i++) {
         thegenes[i] = new Gene("Gene" + i, 0.0, 10.0, 1.0);
      }
      return thegenes;
   }

   /**
    * In this demo application the fitness is calculated such that the best result
    * can be obtained when all genes add up to 2.5
    *
    * @throws GAException
    * @param info The GAInformation object which provides information about the
    * caller, ignored here.
    * @see GAInformation
    */
   @Override
   public void calcFitness() throws GAException {
      double total = 0.0;
      for (int i=0; i<this.genes.length; i++) {
         total += genes[i].getValue();
      }
      double fit = 2.5-total;
      if (fit<0)
         fit = fit*-1;

      this.fitness = fit;
   }

}
